Index: branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Templates/CompiledLinearProgrammingProblemDefinition.cs
===================================================================
--- branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Templates/CompiledLinearProgrammingProblemDefinition.cs	(revision 16172)
+++ branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Templates/CompiledLinearProgrammingProblemDefinition.cs	(revision 16233)
@@ -6,6 +6,6 @@
 
 namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+
   public class CompiledLinearProgrammingProblemDefinition : CompiledProblemDefinition, ILinearProgrammingProblemDefinition {
-
     private Variable x;
     private Variable y;
@@ -18,5 +18,5 @@
     public void BuildModel(Solver solver) {
       // Use vars.yourVariable to access variables in the variable store i.e. yourVariable
-      // Example model taken from https://developers.google.com/optimization/mip/integer_opt 
+      // Example model taken from https://developers.google.com/optimization/mip/integer_opt
       // Define the decision variables
       x = solver.MakeIntVar(0, 3.5, "x");
Index: branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Templates/ScriptTemplates.Designer.cs
===================================================================
--- branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Templates/ScriptTemplates.Designer.cs	(revision 16172)
+++ branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Templates/ScriptTemplates.Designer.cs	(revision 16233)
@@ -9,12 +9,4 @@
 //------------------------------------------------------------------------------
 
-using System.CodeDom.Compiler;
-using System.ComponentModel;
-using System.Diagnostics;
-using System.Diagnostics.CodeAnalysis;
-using System.Globalization;
-using System.Resources;
-using System.Runtime.CompilerServices;
-
 namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
   /// <summary>
@@ -25,14 +17,14 @@
   // To add or remove a member, edit your .ResX file then rerun ResGen
   // with the /str option, or rebuild your VS project.
-  [GeneratedCode("System.Resources.Tools.StronglyTypedResourceBuilder", "15.0.0.0")]
-  [DebuggerNonUserCode()]
-  [CompilerGenerated()]
+  [global::System.CodeDom.Compiler.GeneratedCodeAttribute("System.Resources.Tools.StronglyTypedResourceBuilder", "15.0.0.0")]
+  [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+  [global::System.Runtime.CompilerServices.CompilerGeneratedAttribute()]
   internal class ScriptTemplates {
 
-    private static ResourceManager resourceMan;
+    private static global::System.Resources.ResourceManager resourceMan;
 
-    private static CultureInfo resourceCulture;
+    private static global::System.Globalization.CultureInfo resourceCulture;
 
-    [SuppressMessage("Microsoft.Performance", "CA1811:AvoidUncalledPrivateCode")]
+    [global::System.Diagnostics.CodeAnalysis.SuppressMessageAttribute("Microsoft.Performance", "CA1811:AvoidUncalledPrivateCode")]
     internal ScriptTemplates() {
     }
@@ -41,9 +33,9 @@
     ///   Returns the cached ResourceManager instance used by this class.
     /// </summary>
-    [EditorBrowsable(EditorBrowsableState.Advanced)]
-    internal static ResourceManager ResourceManager {
+    [global::System.ComponentModel.EditorBrowsableAttribute(global::System.ComponentModel.EditorBrowsableState.Advanced)]
+    internal static global::System.Resources.ResourceManager ResourceManager {
       get {
-        if (ReferenceEquals(resourceMan, null)) {
-          ResourceManager temp = new ResourceManager("HeuristicLab.MathematicalOptimization.LinearProgramming.Templates.ScriptTemplates" +
+        if (object.ReferenceEquals(resourceMan, null)) {
+          global::System.Resources.ResourceManager temp = new global::System.Resources.ResourceManager("HeuristicLab.MathematicalOptimization.LinearProgramming.Templates.ScriptTemplates" +
                   "", typeof(ScriptTemplates).Assembly);
           resourceMan = temp;
@@ -57,6 +49,6 @@
     ///   resource lookups using this strongly typed resource class.
     /// </summary>
-    [EditorBrowsable(EditorBrowsableState.Advanced)]
-    internal static CultureInfo Culture {
+    [global::System.ComponentModel.EditorBrowsableAttribute(global::System.ComponentModel.EditorBrowsableState.Advanced)]
+    internal static global::System.Globalization.CultureInfo Culture {
       get {
         return resourceCulture;
@@ -68,18 +60,18 @@
 
     /// <summary>
-    ///   Looks up a localized string similar to using System;
-    ///using System.Linq;
-    ///using System.Collections.Generic;
-    ///using HeuristicLab.Common;
-    ///using HeuristicLab.Core;
+    ///   Looks up a localized string similar to using Google.OrTools.LinearSolver;
     ///using HeuristicLab.Data;
-    ///using HeuristicLab.Encodings.BinaryVectorEncoding;
-    ///using HeuristicLab.Encodings.IntegerVectorEncoding;
-    ///using HeuristicLab.Encodings.RealVectorEncoding;
-    ///using HeuristicLab.Encodings.PermutationEncoding;
-    ///using HeuristicLab.Encodings.LinearLinkageEncoding;
-    ///using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+    ///using HeuristicLab.MathematicalOptimization.LinearProgramming.Problems;
     ///using HeuristicLab.Optimization;
-    ///using H [rest of string was truncated]&quot;;.
+    ///using HeuristicLab.Problems.Programmable;
+    ///
+    ///namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+    ///  public class CompiledLinearProgrammingProblemDefinition : CompiledProblemDefinition, ILinearProgrammingProblemDefinition {
+    ///
+    ///    private Variable x;
+    ///    private Variable y;
+    ///
+    ///    public override void Initialize() {
+    ///      // [rest of string was truncated]&quot;;.
     /// </summary>
     internal static string CompiledLinearProgrammingProblemDefinition {
Index: branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Templates/ScriptTemplates.resx
===================================================================
--- branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Templates/ScriptTemplates.resx	(revision 16172)
+++ branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Templates/ScriptTemplates.resx	(revision 16233)
@@ -60,6 +60,6 @@
             : and then encoded with base64 encoding.
     -->
-  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
-    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/QualityUpdateIntervalMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/QualityUpdateIntervalML/1998/namespace" />
     <xsd:element name="root" msdata:IsDataSet="true">
       <xsd:complexType>