Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 15943)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 16240)
@@ -167,4 +167,6 @@
     <Compile Include="Regression\MibaFriction\CF1.cs" />
     <Compile Include="Regression\MibaFriction\MibaFrictionRegressionInstanceProvider.cs" />
+    <Compile Include="Regression\PennML\PennMLRegressionDataDescriptor.cs" />
+    <Compile Include="Regression\PennML\PennMLRegressionInstanceProvider.cs" />
     <Compile Include="Regression\VariableNetworks\LinearVariableNetwork.cs" />
     <Compile Include="Regression\VariableNetworks\GaussianProcessVariableNetwork.cs" />
@@ -257,4 +259,5 @@
     <EmbeddedResource Include="Regression\Data\RegressionRealWorld.zip" />
     <EmbeddedResource Include="Regression\Data\MibaFriction.zip" />
+    <EmbeddedResource Include="Regression\Data\PennML.zip" />
   </ItemGroup>
   <ItemGroup>
@@ -308,4 +311,5 @@
     </ProjectReference>
   </ItemGroup>
+  <ItemGroup />
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF1.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF1.cs	(revision 15943)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF1.cs	(revision 16240)
@@ -22,6 +22,6 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class CF1 : ResourceRegressionDataDescriptor {
-    public CF1(string resourceName) : base(resourceName) { }
-    public override string Name { get { return "CF1"; } }
+    public CF1() : base("CF1.csv") { }
+    public override string Name { get { return "CF1"; } }    
     public override string Description {
       get {
@@ -34,13 +34,17 @@
     protected override string TargetVariable { get { return "Cf1"; } }
     protected override string[] VariableNames {
-      get { return new string[] { "Partition", "Source1", "Source2", "x1", "Material_Cat", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "Material", "Grooving", "Oil", "x17", "x18", "x19", "x20", "x21", "x22", "Cf1"
- }; }
+      get {
+        return new string[] { "Partition", "Source1", "Source2", "x1", "Material_Cat", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "Material", "Grooving", "Oil", "x17", "x18", "x19", "x20", "x21", "x22", "Cf1"
+ };
+      }
     }
 
     protected override string[] AllowedInputVariables {
-      get { return new string[] { "Material_Cat",
+      get {
+        return new string[] { "Material_Cat",
         "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
         "Material", "Grooving", "Oil",
-        "x17", "x20", "x22" }; }
+        "x17", "x20", "x22" };
+      }
     }
     protected override int TrainingPartitionStart { get { return 0; } }
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF2.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF2.cs	(revision 15943)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF2.cs	(revision 16240)
@@ -22,5 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class CF2 : ResourceRegressionDataDescriptor {
-    public CF2(string resourceName) : base(resourceName) { }
+    public CF2() : base("CF2.csv") { }
     public override string Name { get { return "CF2"; } }
     public override string Description {
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF3.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF3.cs	(revision 15943)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF3.cs	(revision 16240)
@@ -22,5 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class CF3 : ResourceRegressionDataDescriptor {
-    public CF3(string resourceName) : base(resourceName) { }
+    public CF3() : base("CF3.csv") { }
     public override string Name { get { return "CF3"; } }
     public override string Description {
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF4.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF4.cs	(revision 15943)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF4.cs	(revision 16240)
@@ -22,5 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class CF4 : ResourceRegressionDataDescriptor {
-    public CF4(string resourceName) : base(resourceName) { }
+    public CF4() : base("CF4.csv") { }
     public override string Name { get { return "CF4"; } }
     public override string Description {
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/MibaFrictionRegressionInstanceProvider.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/MibaFrictionRegressionInstanceProvider.cs	(revision 15943)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/MibaFrictionRegressionInstanceProvider.cs	(revision 16240)
@@ -47,13 +47,13 @@
     public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
       List<ResourceRegressionDataDescriptor> descriptorList = new List<ResourceRegressionDataDescriptor>();
-      descriptorList.Add(new CF1("CF1.csv"));
-      descriptorList.Add(new CF2("CF2.csv"));
-      descriptorList.Add(new CF3("CF3.csv"));
-      descriptorList.Add(new CF4("CF4.csv"));
-      descriptorList.Add(new NvhRating("NvhRating.csv"));
-      descriptorList.Add(new Temp1("Temp1.csv"));
-      descriptorList.Add(new Temp2("Temp2.csv"));
-      descriptorList.Add(new Wear1("Wear1.csv"));
-      descriptorList.Add(new Wear2("Wear2.csv"));
+      descriptorList.Add(new CF1());
+      descriptorList.Add(new CF2());
+      descriptorList.Add(new CF3());
+      descriptorList.Add(new CF4());
+      descriptorList.Add(new NvhRating());
+      descriptorList.Add(new Temp1());
+      descriptorList.Add(new Temp2());
+      descriptorList.Add(new Wear1());
+      descriptorList.Add(new Wear2());
 
       return descriptorList;
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/NvhRating.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/NvhRating.cs	(revision 15943)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/NvhRating.cs	(revision 16240)
@@ -22,5 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class NvhRating : ResourceRegressionDataDescriptor {
-    public NvhRating(string resourceName) : base(resourceName) { }
+    public NvhRating() : base("NvhRating.csv") { }
     public override string Name { get { return "NvhRating"; } }
     public override string Description {
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp1.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp1.cs	(revision 15943)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp1.cs	(revision 16240)
@@ -22,5 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Temp1 : ResourceRegressionDataDescriptor {
-    public Temp1(string resourceName) : base(resourceName) { }
+    public Temp1() : base("Temp1.csv") { }
     public override string Name { get { return "Temp1"; } }
     public override string Description {
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp2.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp2.cs	(revision 15943)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp2.cs	(revision 16240)
@@ -22,5 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Temp2 : ResourceRegressionDataDescriptor {
-    public Temp2(string resourceName) : base(resourceName) { }
+    public Temp2() : base("Temp2.csv") { }
     public override string Name { get { return "Temp2"; } }
     public override string Description {
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear1.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear1.cs	(revision 15943)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear1.cs	(revision 16240)
@@ -22,5 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Wear1 : ResourceRegressionDataDescriptor {
-    public Wear1(string resourceName) : base(resourceName) { }
+    public Wear1() : base("Wear1.csv") { }
     public override string Name { get { return "Wear1"; } }
     public override string Description {
@@ -33,4 +33,5 @@
     }
     protected override string TargetVariable { get { return "Wear1"; } }
+
     protected override string[] VariableNames {
       get { return new string[] { "Partition", "Source1", "Source2", "x1", "Material_Cat", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "Material", "Grooving", "Oil", "x17", "x18", "x19", "x20", "x21", "x22", "Wear1"
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear2.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear2.cs	(revision 15943)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear2.cs	(revision 16240)
@@ -22,5 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Wear2 : ResourceRegressionDataDescriptor {
-    public Wear2(string resourceName) : base(resourceName) { }
+    public Wear2() : base("Wear2.csv") { }
     public override string Name { get { return "Wear2"; } }
     public override string Description {
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/PennML/PennMLRegressionDataDescriptor.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/PennML/PennMLRegressionDataDescriptor.cs	(revision 16240)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/PennML/PennMLRegressionDataDescriptor.cs	(revision 16240)
@@ -0,0 +1,86 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class PennMLRegressionDataDescriptor : ResourceRegressionDataDescriptor {
+    private readonly string[] variableNames;
+    private readonly string[] allowedInputVariables;
+    private readonly string target;
+    private readonly int trainStart;
+    private readonly int trainEnd;
+    private readonly int testStart;
+    private readonly int testEnd;
+
+    public PennMLRegressionDataDescriptor(string resourceName) : base(resourceName) { }
+
+    public PennMLRegressionDataDescriptor(string resourceName, IEnumerable<string> variableNames, IEnumerable<string> allowedInputVariables, string target,
+      IntRange trainRange, IntRange testRange) : this(resourceName) {
+      this.variableNames = variableNames.ToArray();
+      this.allowedInputVariables = allowedInputVariables.ToArray();
+      this.target = target;
+
+      this.trainStart = trainRange.Start;
+      this.trainEnd = trainRange.End;
+      this.testStart = testRange.Start;
+      this.testEnd = testRange.End;
+    }
+
+    public override string Name {
+      get { return ResourceName.Replace(".csv", ""); }
+    }
+
+    public override string Description {
+      get { return "No description available."; }
+    }
+
+    protected override string TargetVariable {
+      get { return target; }
+    }
+
+    protected override string[] VariableNames {
+      get { return variableNames; }
+    }
+
+    protected override string[] AllowedInputVariables {
+      get { return allowedInputVariables; }
+    }
+
+    protected override int TrainingPartitionStart {
+      get { return trainStart; }
+    }
+
+    protected override int TrainingPartitionEnd {
+      get { return trainEnd; }
+    }
+
+    protected override int TestPartitionStart {
+      get { return testStart; }
+    }
+
+    protected override int TestPartitionEnd {
+      get { return testEnd; }
+    }
+  }
+}
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/PennML/PennMLRegressionInstanceProvider.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/PennML/PennMLRegressionInstanceProvider.cs	(revision 16240)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/PennML/PennMLRegressionInstanceProvider.cs	(revision 16240)
@@ -0,0 +1,91 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Globalization;
+using System.IO;
+using System.IO.Compression;
+using System.Linq;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class PennMLRegressionInstanceProvider : ResourceRegressionInstanceProvider {
+    public override string Name {
+      get { return "PennML Regression Problems"; }
+    }
+
+    public override string Description {
+      get { return "A set of datasets used for benchmarking symbolic regression algorithms."; }
+    }
+
+    public override Uri WebLink {
+      get { return new Uri("https://github.com/EpistasisLab/penn-ml-benchmarks"); }
+    }
+
+    public override string ReferencePublication {
+      get { return "Patryk Orzechowski, William La Cava, Jason H. Moore - Where are we now? A large benchmark study of recent symbolic regression methods"; }
+    }
+
+    protected override string FileName {
+      get { return "PennML"; }
+    }
+
+    // the reference publication uses 75% of the samples in each of the datasets for training and the remaining 25% for testing 
+    private const double trainTestSplit = 0.75;
+
+    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
+      var instanceArchiveName = GetResourceName(FileName + @"\.zip");
+      using (var instancesZipFile = new ZipArchive(GetType().Assembly.GetManifestResourceStream(instanceArchiveName), ZipArchiveMode.Read)) {
+        foreach (var entry in instancesZipFile.Entries) {
+          NumberFormatInfo numberFormat;
+          DateTimeFormatInfo dateFormat;
+          char separator;
+          using (var stream = entry.Open()) {
+            // the method below disposes the stream 
+            TableFileParser.DetermineFileFormat(stream, out numberFormat, out dateFormat, out separator);
+          }
+
+          using (var stream = entry.Open()) {
+            using (var reader = new StreamReader(stream)) {
+              var header = reader.ReadLine(); // read the first line
+
+              // by convention each dataset from the PennML collection reserves the last column for the target
+              var variableNames = header.Split(separator);
+              var allowedInputVariables = variableNames.Take(variableNames.Length - 1);
+              var target = variableNames.Last();
+
+              // count lines
+              int lines = 0; while (reader.ReadLine() != null) lines++;
+
+              var trainEnd = (int)Math.Round(lines * trainTestSplit);
+              var trainRange = new IntRange(0, trainEnd);
+              var testRange = new IntRange(trainEnd, lines);
+
+              var descriptor = new PennMLRegressionDataDescriptor(entry.Name, variableNames, allowedInputVariables, target, trainRange, testRange);
+              yield return descriptor;
+            }
+          }
+        }
+      }
+    }
+  }
+}
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/ChemicalOne.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/ChemicalOne.cs	(revision 15943)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/ChemicalOne.cs	(revision 16240)
@@ -22,5 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class ChemicalOne : ResourceRegressionDataDescriptor {
-    public ChemicalOne(string resourceName) : base(resourceName) { }
+    public ChemicalOne() : base("Chemical-I.csv") { }
     public override string Name { get { return "Chemical-I"; } }
     public override string Description { get { return ""; } }
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Housing.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Housing.cs	(revision 15943)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Housing.cs	(revision 16240)
@@ -22,5 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Housing : ResourceRegressionDataDescriptor {
-    public Housing(string resourceName) : base(resourceName) { }
+    public Housing() : base("Housing.csv") { }
     public override string Name { get { return "Housing"; } }
     public override string Description { get { return ""; } }
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Powermeter.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Powermeter.cs	(revision 15943)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Powermeter.cs	(revision 16240)
@@ -24,5 +24,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Powermeter : ResourceRegressionDataDescriptor {
-    public Powermeter(string resourceName) : base(resourceName) { }
+    public Powermeter() : base("Powermeter.txt") { }
     public override string Name { get { return "Powermeter"; } }
     public override string Description {
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/RealWorldRegressionInstanceProvider.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/RealWorldRegressionInstanceProvider.cs	(revision 15943)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/RealWorldRegressionInstanceProvider.cs	(revision 16240)
@@ -47,9 +47,9 @@
     public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
       List<ResourceRegressionDataDescriptor> descriptorList = new List<ResourceRegressionDataDescriptor>();
-      descriptorList.Add(new ChemicalOne("Chemical-I.csv"));
-      descriptorList.Add(new Housing("Housing.csv"));
-      descriptorList.Add(new Tower("Tower.txt"));
-      descriptorList.Add(new Powermeter("Powermeter.txt"));
-      descriptorList.Add(new SARCOS("SARCOS - Inverse Dynamics.txt"));
+      descriptorList.Add(new ChemicalOne());
+      descriptorList.Add(new Housing());
+      descriptorList.Add(new Tower());
+      descriptorList.Add(new Powermeter());
+      descriptorList.Add(new SARCOS());
       return descriptorList;
     }
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/SARCOS.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/SARCOS.cs	(revision 15943)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/SARCOS.cs	(revision 16240)
@@ -24,5 +24,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class SARCOS : ResourceRegressionDataDescriptor {
-    public SARCOS(string resourceName) : base(resourceName) { }
+    public SARCOS() : base("SARCOS - Inverse Dynamics.txt") { }
     public override string Name { get { return "SARCOS - Inverse Dynamics"; } }
     public override string Description {
Index: branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Tower.cs
===================================================================
--- branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Tower.cs	(revision 15943)
+++ branches/2915-AbsoluteSymbol/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Tower.cs	(revision 16240)
@@ -24,5 +24,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Tower : ResourceRegressionDataDescriptor {
-    public Tower(string resourceName) : base(resourceName) { }
+    public Tower() : base("Tower.txt") { }
     public override string Name { get { return "Tower"; } }
     public override string Description {